var chm,
	h = function(){};
	//	listener
	try{
	chrome.extension.onConnect.addListener(
		function(port){
			port.onMessage.addListener(function(msg,port){
				if ( port.name == 'request_text' ) {
					chm.responseText(msg,port);
				}
				else if ( port.name == 'request_tk' ) {
					chm.responseEachTk(msg,port);
				}
				else if ( port.name == 'request_adz' ) {
					chm.responseAuctionDC(msg,port);
				}
				// 保存文案模板-接收请求
				else if ( port.name == 'request_saveDocTemp') {
					chm.saveDocTemp(msg,port);
				}
				// 保存文案模板-接收请求
				else if ( port.name == 'request_checkVersion') {
					chm.getVersion(port);
				}
			});
		});
	}catch(e){}
	//	Cross-domain infomation
	h.prototype.getData = function(a,b,c,g){
		var xhr = new XMLHttpRequest(), d, s = '', i;
		xhr.open(a, b, true);
		xhr.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		xhr.onreadystatechange = function(){
			if (xhr.readyState == 4) {
				if(xhr.status == 200) {
					d = JSON.parse(xhr.responseText);
					c.postMessage({requestValue:d});
				} else if(xhr.status >= 400) {
					c.postMessage({requestValue: '{msg: "请求失败", code: "-99"}'});
				}
			}
			
		}
		if ( g ) {
			for(i in g) {
				s+= i+'='+g[i]+'&';
			}
			g = s.replace(/&$/, '');
			xhr.send(g);
		}
		else {
			xhr.send();
		}
	};
	//	response and send brower infomation
	h.prototype.responseText = function(msg,port) {
		var a = msg.url, b, c = $.Deferred();
		if ( a == 'a') {
			b = 'response_a_cookie';
			cke.getTBCookies(msg.requestValue)
			.done(function(d){
				port.postMessage({response:b,requestValue:d,url:a})
			}).fail(function(d){return c.reject(d.error)})
		}
		else if ( a == 'b' ) {
			b = 'response_b_cookie';
			cke.getAliCookies(msg.requestValue)
			.done(function(d){
				port.postMessage({response:b,requestValue:d,url:a})
			}).fail(function(d){return c.reject(d.error)})
		}
		else if ( a == 'c' ){
			b = 'response_c_cookie';
			chm.onlineNum(msg.requestValue,b,port);
		}
	};
	//	response turn
	h.prototype.responseAuctionDC = function(msg,port){
		var a = msg.requestValue;
		if ( a == 'req_adz_id' ) {
			chm.getAdzonesId(msg,port)
		}
		else if ( a == 'req_adz_auction' ) {
			chm.getAuction(msg,port);
		} 
	};
	//	response tk infomation
	h.prototype.responseEachTk = function(msg,port){
		var a = msg.requestValue;
		if ( a == 'user_login_status' ) {
			chm.getLoginStatus(port);
		}
		else if ( a == 'req_tk_pid' ) {
			chm.getUserPID(port);
		}
		else if ( a == 'req_tk_turn' ) {
			chm.getTurnLink(msg,port);
		}
		else if ( a == 'req_sina_link' ) {
			chm.getSinaShortLink(msg,port);
		}
		else if ( a == 'req_baidu_link' ) {
			chm.getBaiduShortLink(msg,port);
		}
		else if ( a == 'req_tk_coupon' ) {
			chm.getHiddenCoupon(msg,port);
		}
		else if ( a == 'req_tk_img' ) {
			chm.getCopyUrl(msg,port);
		}
		// 获取userid
		else if ( a == 'req_tk_id' ) {
			chm.getUserID(port);
		}
		// 获取保存文案
		else if ( a == 'req_tk_doc' ) {
			chm.getSaveDocTemp(msg,port);
		}
		// 获取二合一转链
		else if (a == 'req_tk_2in1') {
			chm.getTwoInOne(msg,port);
		}
		// 获取商品信息
		else if (a == 'req_tk_goods') {
			chm.getGoodsInfo(msg,port);
		}
		// 获取普通优惠券
		else if (a == 'req_tk_normalCoupon') {
			chm.getNormalCoupon(msg,port);
		}
		// 获取超市商品优惠券列表
		else if (a == 'req_tk_marketCouponList') {
			chm.getMarketCouponList(msg,port);
		}
	};
	h.prototype.getLoginStatus = function(c){
		this.getData('GET','http://www.yetaoke.com/api/getInterData',c);
	};
	h.prototype.getUserPID = function(c){
		this.getData('GET','http://www.yetaoke.com/api/getUserPID',c);
	};
	h.prototype.getTurnLink = function(a,c){
		this.getData('POST','http://www.yetaoke.com/api/getTwoInOne',c,a.data);
	};
	// 获取新浪短链
	h.prototype.getSinaShortLink = function(a,c){
		this.getData('GET','https://api.t.sina.com.cn/short_url/shorten.json?source=5786724301&url_long='+a.data+'',c);
	};
	// 获取百度短链
	h.prototype.getBaiduShortLink = function(a,c){
		$.post('http://dwz.cn/create.php', a.data, function (resulte) {
			c.postMessage({requestValue: JSON.parse(resulte)});
		});
	};
	h.prototype.getHiddenCoupon = function(a,c){
		this.getData('POST','http://www.yetaoke.com/api/getCoupon',c,a.data);
	};
	h.prototype.onlineNum = function(a,b,c){
		this.getData('GET','http://www.qingtaoke.com/api/goodsSelf/online?goodsid='+a+'&t='+(new Date()).getTime()+'',c,b);
	};
	h.prototype.getCopyUrl = function(a,c){
		this.getData('GET','http://www.yetaoke.com/api/getImgUrl?imgUrl='+a.data+'',c);
	};
	h.prototype.getAdzonesId = function(a,c){
		this.getData('GET','http://pub.alimama.com/common/adzone/adzoneManage.json?tab=3&toPage=1&perPageSize=40&gcid=8&pvid=&t='+(new Date()).getTime()+'&_tb_token_='+a.token+'&_input_charset=utf-8',c);
	};
	h.prototype.getAuction = function(a,c){
		this.getData('GET','http://pub.alimama.com/common/code/getAuctionCode.json?auctionid='+a.data.auctionid+'&adzoneid='+a.data.adzoneid+'&siteid='+a.data.siteid+'&scenes=1&t='+(new Date()).getTime()+'&_tb_token_='+a.data.token+'',c);
	};
	// 保存文案模板
	h.prototype.saveDocTemp = function(a,c){
		this.getData('POST','http://www.yetaoke.com/user/help/wenan/save',c,a);
	};
	// 获取保存的文案模板
	h.prototype.getSaveDocTemp = function(a,c){
		this.getData('POST','http://www.yetaoke.com/wenAn?uid='+a.data,c);
	};
	// 获取userid
	h.prototype.getUserID = function(c){
		this.getData('GET','http://www.yetaoke.com/getPuserId',c);
	};
	// 获取二合一转链
	h.prototype.getTwoInOne = function(a,c){
		this.getData('GET','http://www.yetaoke.com/qdgetTwoInOne?couponId=' + a.data.coupon_id + '&itemId=' + a.data.item_id + '&pid=' + a.data.pid + '&mobile=' + a.data.mobile + '&text=' + a.data.title, c);
	};
	// 获取商品信息
	// h.prototype.getGoodsInfo = function(a,c){
	// 	this.getData('GET','http://hws.m.taobao.com/cache/wdetail/5.0/?id=' + a.data.item_id, c);
	// };
	h.prototype.getGoodsInfo = function(a,c){
		this.getData('GET','https://pub.alimama.com/items/search.json?q=' + a.data.item_url + '&auctionTag=&perPageSize=40&shopTag=', c);
	};
	// 获取普通优惠券
	h.prototype.getNormalCoupon = function(a,c){
		this.getData('GET','https://cart.taobao.com/json/GetPriceVolume.do?sellerId=' + a.data.seller_id, c);
	};
	// 获取超市商品优惠券列表
	h.prototype.getMarketCouponList = function (a, c) {
		this.getData('POST','http://www.qingtaoke.com/api/UserPlan/UserCouponList',c,a.data);
	};
	// 获取最新版本
	h.prototype.getVersion = function (c) {
		var xhr = new XMLHttpRequest(), d, s = '', i;
		xhr.open('GET', 'http://www.yetaoke.com/api/getPluginVersion', true);
		xhr.setRequestHeader("Content-type","application/x-www-form-urlencoded");
		xhr.onreadystatechange = function(){
			if(xhr.readyState == 4 && xhr.status == 200) {
				d = xhr.responseText;
				c.postMessage({requestValue:d});
			}
		}
		xhr.send();
	};

	chm = new h();