/*
* module
*/
var pcsCoupon;
	function p(){};
	//	处理优惠券
	p.prototype.processCoupon = function(){
		var b = $.Deferred(), p, a, m, t;
		return _cop
		.done(function(d){
			if (typeof d !== 'undefined' && d.length > 0) {
				var result, j = 0;
				d = pcsCoupon.processCouponSort(d);
				t = pcsCoupon.findMaxDerate(d);
				c = tip.getItemId();
				m = ( t === void 0 ? null : t);
				for (var i = 0, len = d.length; i < len; i++) {
					p = d[i];
					p.exPrice = m;
					p.tradeId = c;
					(function(e){
						mdlCoupon.getCouponDetail(e)
						.done(function(l){
							j ++;
							l[0].timeRange = (l[0].startTime).substring(5,10)+' ~ '+(l[0].endTime).substring(5,10);
							v.viewCoupon(e,l[0]);
							if (j == i && result) {
								window.open(result);
							}
						}).fail(function(d){
							j++;
							if (typeof d.ret !== 'undefined' && d.ret[0].indexOf('FAIL_SYS_USER_VALIDATE') > -1) {
								result = d.data.url;
							} else if (/^RETURN_FAIL_TOKEN$/.test(d)) {
								a = '\u67e5\u8be2\u5931\u8d25';
								v.viewCoupon(a),
								b.reject(d);
							} else {
								a = "<a target='_blank' href='https://www.alimama.com/member/login.htm' class='a-hover'>"+d+"</a>";
								v.viewCoupon(a),
								b.reject(d);
							}

							if (j == i && result) {
								window.open(result);
							}
						});
					}(p));
				}
			}
			else {
				v.viewCoupon("\u6682\u65e0\u4f18\u60e0\u5238");
				return b.resolve(null);
			}
		}).fail(function(d){
			v.viewCoupon(d);
			return b.reject(d);
		}),b;
	};
	//	最高普通优惠券价格
	p.prototype.findCouponPrice = function(a) {
		var b = new $.Deferred(), h, n, p, c, o, k, limit;
		return _cop.state() == 'pending' ? 
			b.reject()
		: (_cop
			.done(function(d){
				if (typeof d !== 'undefined' && d.length > 0 ) {
					p = parseFloat(d[0].price);
					o = false;
					for (var i = 0, len = d.length; i < len; i++) {
						n = d[i].price;
						if ( p >= parseFloat(n) ) {
							limit = d[i].condition.split('满')[1].split('减')[0];
							p = d[i].price;
							o = true;
						}
					}
					h = {limit: limit, value: p, ok: o};
					return b.resolve(h);
				}
				else {
					return b.reject();
				}
			}).fail(function(d){
				return b.reject();
			}),b);
	};
	p.prototype.processAliCoupon = function(){
		var id = tip.getItemId();
		mdlCoupon.getAliHideCoupon().done(function(d){
			var a = (d.couponInfo).match(/\d+(.\d+)?/g);
			a[1] === undefined ? d.couponInfo = '\u6ee1'+d.couponStartFee+'\u51cf'+a[0] :
			d.couponInfo = '\u6ee1'+a[0]+'\u51cf'+a[1];
			d.timeRange = (d.couponEffectiveStartTime).substring(5,10)+' ~ '+(d.couponEffectiveEndTime).substring(5,10);
			v.viewAliCoupon(d,id);
		}).fail(function(d){
			v.viewAliCoupon(d);
		});
	};
	p.prototype.processHiddenCoupon = function(){
		mdlCoupon.getHideCoupon()
		.done(function(d){
			var a = d.data;
			if (typeof a !== 'undefined') {
				for (var i = 0 , len = a.length; i < len; i++) {
					a[i].price = a[i].coupon_condition;
					a[i].coupon_condition = "\u6ee1"+parseFloat(a[i].coupon_condition).toFixed(2)+"\u51cf"+a[i].coupon_price;
					a[i].timeRange = (a[i].coupon_start_time).substring(5,10)+' ~ '+(a[i].coupon_end_time).substring(5,10);
					v.getMaxCoupon(a[i].coupon_id);
					v.viewHiddenCoupon(a[i]);
				}
			}
		})
		.fail(function(d){});
	};
	//	优惠券排序
	p.prototype.processCouponSort = function(b){
		var n;
		if (typeof b !== 'undefined' && b.length > 1) {
			for (var j = 0, len = b.length; j < len; j++) {
				for (var i = 0; i < len - j - 1; i++) {
					if ( parseFloat(b[i].price) < parseFloat(b[i+1].price) ) {
						n = b[i];
						b[i] = b[i+1];
						b[i+1] = n;
					}
				}
			}
		}
		return b;
	};
	p.prototype.findMaxDerate = function(d){
		var a, b, c, e = _uninfo.context.zkPrice;
		if (typeof b !== 'undefined' && d.length > 0) {
			for (a = 0, b = d.length; a < b; a++) {
				c = parseFloat((d[a].condition).match(/\d+/));
				if ( c <= e ) {
					return v.getMaxCoupon(d[a].id),d[a].price;
				}
			}
		}
	};

	// 处理超市商品优惠券
	p.prototype.processMarketCoupon = function () {
		mdlCoupon.getMarketCouponList()
		.done(function (data) {
			var result,
				j = 0;
			for (var i = 0, len = data.data.length; i < len; i ++) {
				var coupon = {id: data.data[i].activityId};

				mdlCoupon.getCouponDetail(coupon)
				.done(function (info) {
					var _info, _data, _info_startFee, _info_price;

					j++;

					if (typeof d.ret !== 'undefined' && info.ret[0] === 'FAIL_SYS_USER_VALIDATE::哎哟喂,被挤爆啦,请稍后重试!') {
						if (!result) {
							result = info.data.url;
						}
					} else {
						_info = info.data.module[0];
						_info_startFee = _info.startFee.substring(0, _info.startFee.length - 2) + '.' + _info.startFee.substring(_info.startFee.length - 2);
						_info_price = _info.discount.substring(0, _info.discount.length - 2) + '.' + _info.discount.substring(_info.discount.length - 2);
						_data = {
							coupon_id: _info.uuid,
							price: _info_startFee,
							coupon_price: _info_price,
							coupon_condition: '满' + Number(_info_startFee) + '减' + Number(_info_price),
							timeRange: (_info.startTime).substring(5,10)+' ~ '+(_info.endTime).substring(5,10),
							coupon_start_time: _info.startTime,
							coupon_end_time: _info.endTime,
							seller_id: _info.sellerId,
							tradeId: tip.getItemId()
						};
						v.viewHiddenCoupon(_data);
					}
					
					if (j == i && result) {
						window.open(result);
					}
				})
				.fail(function () {});
			}
		})
		.fail(function (data) {
		})
	}

	pcsCoupon = new p();